diff --git a/mysql-test/main/sp-expr.test b/mysql-test/main/sp-expr.test
new file mode 100644
index 0000000..6c61e7a
--- /dev/null
+++ b/mysql-test/main/sp-expr.test
@@ -0,0 +1,804 @@
+# Testing expressions of different kinds in various parts of SP syntax
+
+--echo #
+--echo # Start of 10.4 tests
+--echo #
+
+#
+# Subselects in SP control structures
+#
+
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (1);
+DELIMITER $$;
+
+BEGIN NOT ATOMIC
+  CASE ((1) IN (SELECT a FROM t1)) WHEN 1 THEN SELECT 1;
+  ELSE SELECT NULL;
+  END CASE;
+END;
+$$
+BEGIN NOT ATOMIC
+  CASE (EXISTS (SELECT a FROM t1)) WHEN 1 THEN SELECT 1;
+  ELSE SELECT NULL;
+  END CASE;
+END;
+$$
+
+BEGIN NOT ATOMIC
+  IF ((1) IN (SELECT a FROM t1)) THEN SELECT 1;
+  ELSE SELECT NULL;
+  END IF;
+END;
+$$
+BEGIN NOT ATOMIC
+  IF (EXISTS (SELECT a FROM t1)) THEN SELECT 1;
+  ELSE SELECT NULL;
+  END IF;
+END;
+$$
+
+BEGIN NOT ATOMIC
+  WHILE ((1234) IN (SELECT * FROM t1)) DO
+    SELECT 1;
+  END WHILE;
+END;
+$$
+BEGIN NOT ATOMIC
+  WHILE (EXISTS (SELECT * FROM t1 WHERE a=1234)) DO
+    SELECT 1;
+  END WHILE;
+END;
+$$
+
+BEGIN NOT ATOMIC
+  REPEAT
+    SELECT 1;
+  UNTIL (1 IN (SELECT * FROM t1))
+  END REPEAT;
+END;
+$$
+BEGIN NOT ATOMIC
+  REPEAT
+    SELECT 1;
+  UNTIL EXISTS (SELECT * FROM t1 WHERE a=1)
+  END REPEAT;
+END;
+$$
+
+BEGIN NOT ATOMIC
+  FOR i IN 0..(1 IN (SELECT * FROM t1))
+  DO
+    SELECT i;
+  END FOR;
+END;
+$$
+BEGIN NOT ATOMIC
+  FOR i IN 0..EXISTS (SELECT * FROM t1 WHERE a=1)
+  DO
+    SELECT i;
+  END FOR;
+END;
+$$
+DELIMITER ;$$
+DROP TABLE t1;
+
+
+#
+# Subselects as SP variable default values
+#
+
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (10);
+DELIMITER $$;
+BEGIN NOT ATOMIC
+  DECLARE a INT DEFAULT ((10) IN (SELECT * FROM t1));
+  SELECT a;
+END;
+$$
+BEGIN NOT ATOMIC
+  DECLARE a INT DEFAULT EXISTS (SELECT * FROM t1);
+  SELECT a;
+END;
+$$
+DELIMITER ;$$
+DROP TABLE t1;
+
+
+#
+# Subselects SP function return values
+#
+
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (1);
+DELIMITER $$;
+CREATE FUNCTION f1() RETURNS INT
+BEGIN
+  RETURN ((1) IN (SELECT * FROM t1));
+END;
+$$
+CREATE FUNCTION f2() RETURNS INT
+BEGIN
+  RETURN EXISTS (SELECT * FROM t1 WHERE a=1);
+END;
+$$
+DELIMITER ;$$
+SELECT f1();
+SELECT f2();
+DROP FUNCTION f1;
+DROP FUNCTION f2;
+DROP TABLE t1;
+
+
+#
+# Subselects in CURSOR parameters
+#
+
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (1),(2),(3);
+DELIMITER $$;
+BEGIN NOT ATOMIC
+  DECLARE va INT;
+  DECLARE cur CURSOR(amin INT) FOR SELECT a FROM t1 WHERE a>amin ORDER BY a;
+  OPEN cur(1 IN (SELECT * FROM t1));
+  FETCH cur INTO va;
+  SELECT va;
+  CLOSE cur;
+END;
+$$
+BEGIN NOT ATOMIC
+  DECLARE va INT;
+  DECLARE cur CURSOR(amin INT) FOR SELECT a FROM t1 WHERE a>amin ORDER BY a;
+  OPEN cur(EXISTS (SELECT * FROM t1));
+  FETCH cur INTO va;
+  SELECT va;
+  CLOSE cur;
+END;
+$$
+DELIMITER ;$$
+DROP TABLE t1;
+
+
+--echo #
+--echo # MDEV-14347 CREATE PROCEDURE returns no error when using an unknown variable
+--echo #
+
+#
+# Unknown identifiers in CASE SP control
+#
+
+DELIMITER $$;
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1()
+BEGIN
+  CASE unknown_identifier WHEN 1 THEN SELECT 1;
+  ELSE SELECT NULL;
+  END CASE;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1()
+BEGIN
+  CASE unknown_identifier.a WHEN 1 THEN SELECT 1;
+  ELSE SELECT NULL;
+  END CASE;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1()
+BEGIN
+  CASE unknown_identifier.a.b WHEN 1 THEN SELECT 1;
+  ELSE SELECT NULL;
+  END CASE;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1()
+BEGIN
+  CASE unknown_identifier.a.b.c WHEN 1 THEN SELECT 1;
+  ELSE SELECT NULL;
+  END CASE;
+END;
+$$
+
+
+#
+# Unknown identifier in IF
+#
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1()
+BEGIN
+  IF unknown_identifier THEN SELECT 1;
+  ELSE SELECT NULL;
+  END IF;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1()
+BEGIN
+  IF unknown_identifier.a THEN SELECT 1;
+  ELSE SELECT NULL;
+  END IF;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1()
+BEGIN
+  IF unknown_identifier.a.b THEN SELECT 1;
+  ELSE SELECT NULL;
+  END IF;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1()
+BEGIN
+  IF unknown_identifier.a.b.c THEN SELECT 1;
+  ELSE SELECT NULL;
+  END IF;
+END;
+$$
+
+
+#
+# Unknown identifier in WHILE
+#
+
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1()
+BEGIN
+  WHILE unknown_identifier DO
+    SELECT 1;
+  END WHILE;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1()
+BEGIN
+  WHILE unknown_identifier.a DO
+    SELECT 1;
+  END WHILE;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1()
+BEGIN
+  WHILE unknown_identifier.a.b DO
+    SELECT 1;
+  END WHILE;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1()
+BEGIN
+  WHILE unknown_identifier.a.b.c DO
+    SELECT 1;
+  END WHILE;
+END;
+$$
+
+
+
+#
+# Unknown identifier in REPEAT
+#
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1()
+BEGIN
+  REPEAT
+    SELECT 1;
+  UNTIL unknown_identifier;
+  END REPEAT;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1()
+BEGIN
+  REPEAT
+    SELECT 1;
+  UNTIL unknown_identifier.a;
+  END REPEAT;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1()
+BEGIN
+  REPEAT
+    SELECT 1;
+  UNTIL unknown_identifier.a.b;
+  END REPEAT;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1()
+BEGIN
+  REPEAT
+    SELECT 1;
+  UNTIL unknown_identifier.a.b.c;
+  END REPEAT;
+END;
+$$
+
+
+#
+# Unknown identifier in FOR
+#
+
+--error ER_SP_UNDECLARED_VAR
+CREATE PROCEDURE p1()
+BEGIN
+  FOR i IN 0..unknown_identifier
+  DO
+    SELECT i;
+  END FOR;
+END;
+$$
+
+--error ER_SP_UNDECLARED_VAR
+CREATE PROCEDURE p1()
+BEGIN
+  FOR i IN 0..unknown_identifier.field1
+  DO
+    SELECT i;
+  END FOR;
+END;
+$$
+
+--error ER_SP_UNDECLARED_VAR
+CREATE PROCEDURE p1()
+BEGIN
+  FOR i IN 0..unknown_identifier.field1.field2
+  DO
+    SELECT i;
+  END FOR;
+END;
+$$
+
+--error ER_SP_UNDECLARED_VAR
+CREATE PROCEDURE p1()
+BEGIN
+  FOR i IN unknown_identifier..10
+  DO
+    SELECT i;
+  END FOR;
+END;
+$$
+
+--error ER_SP_UNDECLARED_VAR
+CREATE PROCEDURE p1()
+BEGIN
+  FOR i IN unknown_identifier.field1..10
+  DO
+    SELECT i;
+  END FOR;
+END;
+$$
+
+--error ER_SP_UNDECLARED_VAR
+CREATE PROCEDURE p1()
+BEGIN
+  FOR i IN unknown_identifier.field1.field2..10
+  DO
+    SELECT i;
+  END FOR;
+END;
+$$
+
+DELIMITER ;$$
+
+
+#
+# Unknown identifiers as SP variable default values
+#
+
+DELIMITER $$;
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1()
+BEGIN
+  DECLARE a INT DEFAULT unknown_identifier;
+  SELECT a;
+END;
+$$
+DELIMITER ;$$
+
+
+DELIMITER $$;
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1()
+BEGIN
+  DECLARE a INT DEFAULT unknown_identifier.a;
+  SELECT a;
+END;
+$$
+DELIMITER ;$$
+
+
+DELIMITER $$;
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1()
+BEGIN
+  DECLARE a INT DEFAULT unknown_identifier.a.b;
+  SELECT a;
+END;
+$$
+DELIMITER ;$$
+
+
+#
+# Unknown identifiers as SP function return values
+#
+
+--error ER_BAD_FIELD_ERROR
+CREATE FUNCTION f1() RETURNS INT RETURN unknown_identifier;
+
+--error ER_BAD_FIELD_ERROR
+CREATE FUNCTION f1() RETURNS INT RETURN unknown_identifier.a;
+
+--error ER_BAD_FIELD_ERROR
+CREATE FUNCTION f1() RETURNS INT RETURN unknown_identifier.a.b;
+
+--error ER_BAD_FIELD_ERROR
+CREATE FUNCTION f1() RETURNS INT RETURN unknown_identifier.a.b.c;
+
+
+#
+# Unknown identifiers in CURSOR parameters
+#
+
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (1),(2),(3);
+DELIMITER $$;
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1()
+BEGIN
+  DECLARE va INT;
+  DECLARE cur CURSOR(amin INT) FOR SELECT a FROM t1 WHERE a>amin ORDER BY a;
+  OPEN cur(unknown_identifier);
+  FETCH cur INTO va;
+  SELECT va;
+  CLOSE cur;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1()
+BEGIN
+  DECLARE va INT;
+  DECLARE cur CURSOR(amin INT) FOR SELECT a FROM t1 WHERE a>amin ORDER BY a;
+  OPEN cur(unknown_identifier.a);
+  FETCH cur INTO va;
+  SELECT va;
+  CLOSE cur;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1()
+BEGIN
+  DECLARE va INT;
+  DECLARE cur CURSOR(amin INT) FOR SELECT a FROM t1 WHERE a>amin ORDER BY a;
+  OPEN cur(unknown_identifier.a.b);
+  FETCH cur INTO va;
+  SELECT va;
+  CLOSE cur;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1()
+BEGIN
+  DECLARE va INT;
+  DECLARE cur CURSOR(amin INT) FOR SELECT a FROM t1 WHERE a>amin ORDER BY a;
+  OPEN cur(unknown_identifier.a.b.c);
+  FETCH cur INTO va;
+  SELECT va;
+  CLOSE cur;
+END;
+$$
+
+DELIMITER ;$$
+DROP TABLE t1;
+
+
+--echo #
+--echo # MDEV-14347 CREATE PROCEDURE returns no error when using an unknown variable
+--echo #
+
+--echo # (testing aggregate functions)
+
+#
+# Aggregate functions in CASE SP control
+#
+
+DELIMITER $$;
+
+--error ER_INVALID_GROUP_FUNC_USE
+CREATE PROCEDURE p1()
+BEGIN
+  CASE SUM(1) WHEN 1 THEN SELECT 1;
+  ELSE SELECT NULL;
+  END CASE;
+END;
+$$
+
+
+#
+# Aggregate function in IF
+#
+
+--error ER_INVALID_GROUP_FUNC_USE
+CREATE PROCEDURE p1()
+BEGIN
+  IF SUM(1) THEN SELECT 1;
+  ELSE SELECT NULL;
+  END IF;
+END;
+$$
+
+
+#
+# Aggregate function in WHILE
+#
+
+
+--error ER_INVALID_GROUP_FUNC_USE
+CREATE PROCEDURE p1()
+BEGIN
+  WHILE SUM(1) DO
+    SELECT 1;
+  END WHILE;
+END;
+$$
+
+
+#
+# Aggregate function in REPEAT
+#
+
+--error ER_INVALID_GROUP_FUNC_USE
+CREATE PROCEDURE p1()
+BEGIN
+  REPEAT
+    SELECT 1;
+  UNTIL SUM(1);
+  END REPEAT;
+END;
+$$
+
+
+#
+# Aggregate function in FOR
+#
+
+--error ER_INVALID_GROUP_FUNC_USE
+CREATE PROCEDURE p1()
+BEGIN
+  FOR i IN 0..SUM(1)
+  DO
+    SELECT i;
+  END FOR;
+END;
+$$
+
+
+--error ER_INVALID_GROUP_FUNC_USE
+CREATE PROCEDURE p1()
+BEGIN
+  FOR i IN SUM(1)..10
+  DO
+    SELECT i;
+  END FOR;
+END;
+$$
+
+
+DELIMITER ;$$
+
+
+#
+# Aggregate functions as SP variable default values
+#
+
+DELIMITER $$;
+--error ER_INVALID_GROUP_FUNC_USE
+CREATE PROCEDURE p1()
+BEGIN
+  DECLARE a INT DEFAULT SUM(1);
+  SELECT a;
+END;
+$$
+DELIMITER ;$$
+
+
+
+#
+# Aggregate functions as SP function return values
+#
+
+--error ER_INVALID_GROUP_FUNC_USE
+CREATE FUNCTION f1() RETURNS INT RETURN SUM(1);
+
+
+#
+# Aggregate functions in CURSOR parameters
+#
+
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (1),(2),(3);
+DELIMITER $$;
+
+--error ER_INVALID_GROUP_FUNC_USE
+CREATE PROCEDURE p1()
+BEGIN
+  DECLARE va INT;
+  DECLARE cur CURSOR(amin INT) FOR SELECT a FROM t1 WHERE a>amin ORDER BY a;
+  OPEN cur(SUM(1));
+  FETCH cur INTO va;
+  SELECT va;
+  CLOSE cur;
+END;
+$$
+
+
+DELIMITER ;$$
+DROP TABLE t1;
+
+
+--echo #
+--echo # MDEV-14347 CREATE PROCEDURE returns no error when using an unknown variable
+--echo #
+
+--echo # (testing window functions)
+
+#
+# Aggregate functions in CASE SP control
+#
+
+DELIMITER $$;
+
+--error ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION
+CREATE PROCEDURE p1()
+BEGIN
+  CASE ROW_NUMBER() OVER() WHEN 1 THEN SELECT 1;
+  ELSE SELECT NULL;
+  END CASE;
+END;
+$$
+
+
+#
+# Aggregate function in IF
+#
+
+--error ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION
+CREATE PROCEDURE p1()
+BEGIN
+  IF ROW_NUMBER() OVER() THEN SELECT 1;
+  ELSE SELECT NULL;
+  END IF;
+END;
+$$
+
+
+#
+# Aggregate function in WHILE
+#
+
+
+--error ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION
+CREATE PROCEDURE p1()
+BEGIN
+  WHILE ROW_NUMBER() OVER() DO
+    SELECT 1;
+  END WHILE;
+END;
+$$
+
+
+#
+# Aggregate function in REPEAT
+#
+
+--error ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION
+CREATE PROCEDURE p1()
+BEGIN
+  REPEAT
+    SELECT 1;
+  UNTIL ROW_NUMBER() OVER();
+  END REPEAT;
+END;
+$$
+
+
+#
+# Aggregate function in FOR
+#
+
+--error ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION
+CREATE PROCEDURE p1()
+BEGIN
+  FOR i IN 0..ROW_NUMBER() OVER()
+  DO
+    SELECT i;
+  END FOR;
+END;
+$$
+
+
+--error ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION
+CREATE PROCEDURE p1()
+BEGIN
+  FOR i IN ROW_NUMBER() OVER()..10
+  DO
+    SELECT i;
+  END FOR;
+END;
+$$
+
+
+DELIMITER ;$$
+
+
+#
+# Aggregate functions as SP variable default values
+#
+
+DELIMITER $$;
+--error ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION
+CREATE PROCEDURE p1()
+BEGIN
+  DECLARE a INT DEFAULT ROW_NUMBER() OVER();
+  SELECT a;
+END;
+$$
+DELIMITER ;$$
+
+
+
+#
+# Aggregate functions as SP function return values
+#
+
+--error ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION
+CREATE FUNCTION f1() RETURNS INT RETURN ROW_NUMBER() OVER();
+
+
+#
+# Aggregate functions in CURSOR parameters
+#
+
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (1),(2),(3);
+DELIMITER $$;
+
+--error ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION
+CREATE PROCEDURE p1()
+BEGIN
+  DECLARE va INT;
+  DECLARE cur CURSOR(amin INT) FOR SELECT a FROM t1 WHERE a>amin ORDER BY a;
+  OPEN cur(ROW_NUMBER() OVER());
+  FETCH cur INTO va;
+  SELECT va;
+  CLOSE cur;
+END;
+$$
+
+
+DELIMITER ;$$
+DROP TABLE t1;
diff --git a/mysql-test/main/sp.result b/mysql-test/main/sp.result
index a79d90d..572015d 100644
--- a/mysql-test/main/sp.result
+++ b/mysql-test/main/sp.result
@@ -4179,6 +4179,7 @@ select v, isnull(v);
 end if;
 end;
 end|
+ERROR 42S22: Unknown column 'undefined_var' in 'field list'
 create procedure bug14643_2()
 begin
 declare continue handler for sqlexception select 'boo' as 'Handler';
@@ -4190,18 +4191,7 @@ select 2;
 end case;
 select undefined_var;
 end|
-call bug14643_1()|
-Handler
-boo
-v	isnull(v)
-NULL	1
-call bug14643_2()|
-Handler
-boo
-Handler
-boo
-drop procedure bug14643_1|
-drop procedure bug14643_2|
+ERROR 42S22: Unknown column 'undefined_var' in 'field list'
 drop procedure if exists bug14304|
 drop table if exists t3, t4|
 create table t3(a int primary key auto_increment)|
@@ -4231,9 +4221,7 @@ create procedure bug14376()
 begin
 declare x int default x;
 end|
-call bug14376()|
 ERROR 42S22: Unknown column 'x' in 'field list'
-drop procedure bug14376|
 create procedure bug14376()
 begin
 declare x int default 42;
@@ -4476,6 +4464,7 @@ select 'no' as 'v';
 end if;
 select 'done' as 'End';
 end|
+ERROR 42S22: Unknown column 'v' in 'field list'
 create procedure bug14498_2()
 begin
 declare continue handler for sqlexception select 'error' as 'Handler';
@@ -4484,6 +4473,7 @@ select 'yes' as 'v';
 end while;
 select 'done' as 'End';
 end|
+ERROR 42S22: Unknown column 'v' in 'field list'
 create procedure bug14498_3()
 begin
 declare continue handler for sqlexception select 'error' as 'Handler';
@@ -4492,6 +4482,7 @@ select 'maybe' as 'v';
 until v end repeat;
 select 'done' as 'End';
 end|
+ERROR 42S22: Unknown column 'v' in 'field list'
 create procedure bug14498_4()
 begin
 declare continue handler for sqlexception select 'error' as 'Handler';
@@ -4505,6 +4496,7 @@ select '?' as 'v';
 end case;
 select 'done' as 'End';
 end|
+ERROR 42S22: Unknown column 'v' in 'field list'
 create procedure bug14498_5()
 begin
 declare continue handler for sqlexception select 'error' as 'Handler';
@@ -4518,38 +4510,7 @@ select '?' as 'v';
 end case;
 select 'done' as 'End';
 end|
-call bug14498_1()|
-Handler
-error
-End
-done
-call bug14498_2()|
-Handler
-error
-End
-done
-call bug14498_3()|
-v
-maybe
-Handler
-error
-End
-done
-call bug14498_4()|
-Handler
-error
-End
-done
-call bug14498_5()|
-Handler
-error
-End
-done
-drop procedure bug14498_1|
-drop procedure bug14498_2|
-drop procedure bug14498_3|
-drop procedure bug14498_4|
-drop procedure bug14498_5|
+ERROR 42S22: Unknown column 'v' in 'field list'
 drop table if exists t3|
 drop procedure if exists bug15231_1|
 drop procedure if exists bug15231_2|
@@ -8316,14 +8277,12 @@ DECLARE name VARCHAR(10);
 SET name="hello";
 call p1(name2);
 END|
+ERROR 42S22: Unknown column 'name2' in 'field list'
 call p2();
 a
 hello
-call p3();
-ERROR 42S22: Unknown column 'name2' in 'field list'
 drop procedure p1;
 drop procedure p2;
-drop procedure p3;
 #
 # MDEV-15328: MariaDB 10.2.13 Crashes upon CALL PROCEDURE PARAM
 # LAST_INSERT_ID ()
diff --git a/mysql-test/main/sp.test b/mysql-test/main/sp.test
index 56dea01..3d0a6b8 100644
--- a/mysql-test/main/sp.test
+++ b/mysql-test/main/sp.test
@@ -5040,6 +5040,7 @@ drop procedure if exists bug14643_1|
 drop procedure if exists bug14643_2|
 --enable_warnings
 
+--error ER_BAD_FIELD_ERROR
 create procedure bug14643_1()
 begin
   declare continue handler for sqlexception select 'boo' as 'Handler';
@@ -5055,6 +5056,7 @@ begin
   end;
 end|
 
+--error ER_BAD_FIELD_ERROR
 create procedure bug14643_2()
 begin
   declare continue handler for sqlexception select 'boo' as 'Handler';
@@ -5069,11 +5071,6 @@ begin
   select undefined_var;
 end|
 
-call bug14643_1()|
-call bug14643_2()|
-
-drop procedure bug14643_1|
-drop procedure bug14643_2|
 
 #
 # BUG#14304: auto_increment field incorrect set in SP
@@ -5114,15 +5111,12 @@ drop table t3, t4|
 drop procedure if exists bug14376|
 --enable_warnings
 
+--error ER_BAD_FIELD_ERROR
 create procedure bug14376()
 begin
   declare x int default x;
 end|
 
-# Not the error we want, but that's what we got for now...
---error ER_BAD_FIELD_ERROR
-call bug14376()|
-drop procedure bug14376|
 
 create procedure bug14376()
 begin
@@ -5344,6 +5338,7 @@ drop procedure if exists bug14498_4|
 drop procedure if exists bug14498_5|
 --enable_warnings
 
+--error ER_BAD_FIELD_ERROR
 create procedure bug14498_1()
 begin
   declare continue handler for sqlexception select 'error' as 'Handler';
@@ -5356,6 +5351,7 @@ begin
   select 'done' as 'End';
 end|
 
+--error ER_BAD_FIELD_ERROR
 create procedure bug14498_2()
 begin
   declare continue handler for sqlexception select 'error' as 'Handler';
@@ -5366,6 +5362,7 @@ begin
   select 'done' as 'End';
 end|
 
+--error ER_BAD_FIELD_ERROR
 create procedure bug14498_3()
 begin
   declare continue handler for sqlexception select 'error' as 'Handler';
@@ -5376,6 +5373,7 @@ begin
   select 'done' as 'End';
 end|
 
+--error ER_BAD_FIELD_ERROR
 create procedure bug14498_4()
 begin
   declare continue handler for sqlexception select 'error' as 'Handler';
@@ -5391,6 +5389,7 @@ begin
   select 'done' as 'End';
 end|
 
+--error ER_BAD_FIELD_ERROR
 create procedure bug14498_5()
 begin
   declare continue handler for sqlexception select 'error' as 'Handler';
@@ -5406,17 +5405,6 @@ begin
   select 'done' as 'End';
 end|
 
-call bug14498_1()|
-call bug14498_2()|
-call bug14498_3()|
-call bug14498_4()|
-call bug14498_5()|
-
-drop procedure bug14498_1|
-drop procedure bug14498_2|
-drop procedure bug14498_3|
-drop procedure bug14498_4|
-drop procedure bug14498_5|
 
 #
 # BUG#15231: Stored procedure bug with not found condition handler
@@ -9828,6 +9816,8 @@ BEGIN
   SET name="hello";
   call p1(name);
 END|
+
+--error ER_BAD_FIELD_ERROR
 CREATE OR REPLACE PROCEDURE p3 ()
 BEGIN
   DECLARE name VARCHAR(10);
@@ -9838,11 +9828,8 @@ END|
 DELIMITER ;|
 
 call p2();
---error ER_BAD_FIELD_ERROR
-call p3();
 drop procedure p1;
 drop procedure p2;
-drop procedure p3;
 
 --echo #
 --echo # MDEV-15328: MariaDB 10.2.13 Crashes upon CALL PROCEDURE PARAM
diff --git a/mysql-test/main/statement-expr.result b/mysql-test/main/statement-expr.result
new file mode 100644
index 0000000..2e7e3ab
--- /dev/null
+++ b/mysql-test/main/statement-expr.result
@@ -0,0 +1,217 @@
+CREATE TABLE t1 (id INT, id1 INT);
+INSERT INTO t1 VALUES (1,7);
+INSERT INTO t1 VALUES (1,8);
+SELECT ROW(1,7) IN (SELECT id, id1 FROM t1 WHERE id1= 8);
+ROW(1,7) IN (SELECT id, id1 FROM t1 WHERE id1= 8)
+0
+EXECUTE IMMEDIATE 'SELECT ROW(1, 7) IN (SELECT id, id1 FROM t1 WHERE id1= 8)';
+ROW(1, 7) IN (SELECT id, id1 FROM t1 WHERE id1= 8)
+0
+DROP TABLE t1;
+EXECUTE IMMEDIATE 'SELECT ?' USING (1 IN (SELECT * FROM t1));
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'SELECT * FROM t1))' at line 1
+EXECUTE IMMEDIATE 'SELECT ?' USING (SELECT * FROM t1);
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'SELECT * FROM t1)' at line 1
+CREATE TABLE t1 (id INT);
+INSERT INTO t1 VALUES (10);
+CREATE PROCEDURE p1(a INT) BEGIN END;
+CALL p1((1) IN (SELECT * FROM t1));
+CALL p1(EXISTS (SELECT * FROM t1));
+DROP PROCEDURE p1;
+DROP TABLE t1;
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=(1 IN (SELECT * FROM t1));
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near '(1 IN (SELECT * FROM t1))' at line 1
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=EXISTS (SELECT * FROM t1);
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'EXISTS (SELECT * FROM t1)' at line 1
+BEGIN NOT ATOMIC
+DECLARE CONTINUE HANDLER FOR SQLWARNING
+RESIGNAL SET MYSQL_ERRNO=(1 IN (SELECT * FROM t1));
+SIGNAL SQLSTATE '01000';
+END;
+$$
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near '(1 IN (SELECT * FROM t1));
+SIGNAL SQLSTATE '01000';
+END' at line 3
+BEGIN NOT ATOMIC
+DECLARE CONTINUE HANDLER FOR SQLWARNING
+RESIGNAL SET MYSQL_ERRNO=EXISTS (SELECT * FROM t1);
+SIGNAL SQLSTATE '01000';
+END;
+$$
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'EXISTS (SELECT * FROM t1);
+SIGNAL SQLSTATE '01000';
+END' at line 3
+PREPARE stmt FROM (1 IN (SELECT * FROM t1));
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'SELECT * FROM t1))' at line 1
+PREPARE stmt FROM EXISTS (SELECT * FROM t1);
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near '(SELECT * FROM t1)' at line 1
+EXECUTE IMMEDIATE (1 IN (SELECT * FROM t1));
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'SELECT * FROM t1))' at line 1
+EXECUTE IMMEDIATE EXISTS (SELECT * FROM t1);
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near '(SELECT * FROM t1)' at line 1
+GET DIAGNOSTICS CONDITION (1 IN (SELECT * FROM t1)) @errno=MYSQL_ERRNO;
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near '(1 IN (SELECT * FROM t1)) @errno=MYSQL_ERRNO' at line 1
+GET DIAGNOSTICS CONDITION EXISTS (SELECT * FROM t1) @errno=MYSQL_ERRNO;
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'EXISTS (SELECT * FROM t1) @errno=MYSQL_ERRNO' at line 1
+PURGE BINARY LOGS BEFORE (1 IN (SELECT * FROM t1));
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'SELECT * FROM t1))' at line 1
+PURGE BINARY LOGS BEFORE EXISTS (SELECT * FROM t1);
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near '(SELECT * FROM t1)' at line 1
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (1),(2),(3);
+DO 1 IN (SELECT * FROM t1);
+DO EXISTS (SELECT * FROM t1);
+DROP TABLE t1;
+#
+# MDEV-14347 CREATE PROCEDURE returns no error when using an unknown variable
+#
+EXECUTE IMMEDIATE 'SELECT ?' USING unknown_identifier;
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+EXECUTE IMMEDIATE 'SELECT ?' USING unknown_identifier.a;
+ERROR 42S22: Unknown column 'a' in 'field list'
+EXECUTE IMMEDIATE 'SELECT ?' USING unknown_identifier.a.b;
+ERROR 42S22: Unknown column 'b' in 'field list'
+EXECUTE IMMEDIATE 'SELECT ?' USING unknown_identifier.a.b.c;
+ERROR 42S22: Unknown column 'b' in 'field list'
+CREATE PROCEDURE p1(a INT) BEGIN END;
+CALL p1(unknown_identifier);
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+CALL p1(unknown_identifier.a);
+ERROR 42S22: Unknown column 'a' in 'field list'
+CALL p1(unknown_identifier.a.b);
+ERROR 42S22: Unknown column 'b' in 'field list'
+CALL p1(unknown_identifier.a.b.c);
+ERROR 42S22: Unknown column 'b' in 'field list'
+DROP PROCEDURE p1;
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=unknown_identifier;
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=unknown_identifier.a;
+ERROR 42S22: Unknown column 'a' in 'field list'
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=unknown_identifier.a.b;
+ERROR 42S22: Unknown column 'b' in 'field list'
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=unknown_identifier.a.b.c;
+ERROR 42S22: Unknown column 'b' in 'field list'
+BEGIN NOT ATOMIC
+DECLARE CONTINUE HANDLER FOR SQLWARNING
+RESIGNAL SET MYSQL_ERRNO=unknown_identifier;
+SIGNAL SQLSTATE '01000';
+END;
+$$
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+BEGIN NOT ATOMIC
+DECLARE CONTINUE HANDLER FOR SQLWARNING
+RESIGNAL SET MYSQL_ERRNO=unknown_identifier.a;
+SIGNAL SQLSTATE '01000';
+END;
+$$
+ERROR 42S22: Unknown column 'a' in 'field list'
+BEGIN NOT ATOMIC
+DECLARE CONTINUE HANDLER FOR SQLWARNING
+RESIGNAL SET MYSQL_ERRNO=unknown_identifier.a.b;
+SIGNAL SQLSTATE '01000';
+END;
+$$
+ERROR 42S22: Unknown column 'b' in 'field list'
+BEGIN NOT ATOMIC
+DECLARE CONTINUE HANDLER FOR SQLWARNING
+RESIGNAL SET MYSQL_ERRNO=unknown_identifier.a.b.c;
+SIGNAL SQLSTATE '01000';
+END;
+$$
+ERROR 42S22: Unknown column 'b' in 'field list'
+PREPARE stmt FROM unknown_identifier;
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+PREPARE stmt FROM unknown_identifier.a;
+ERROR 42S22: Unknown column 'a' in 'field list'
+PREPARE stmt FROM unknown_identifier.a.b;
+ERROR 42S22: Unknown column 'b' in 'field list'
+PREPARE stmt FROM unknown_identifier.a.b.c;
+ERROR 42S22: Unknown column 'b' in 'field list'
+EXECUTE IMMEDIATE unknown_identifier;
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+EXECUTE IMMEDIATE unknown_identifier.a;
+ERROR 42S22: Unknown column 'a' in 'field list'
+EXECUTE IMMEDIATE unknown_identifier.a.b;
+ERROR 42S22: Unknown column 'b' in 'field list'
+EXECUTE IMMEDIATE unknown_identifier.a.b.c;
+ERROR 42S22: Unknown column 'b' in 'field list'
+GET DIAGNOSTICS CONDITION unknown_identifier @errno=MYSQL_ERRNO;
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+GET DIAGNOSTICS CONDITION unknown_identifier.a @errno=MYSQL_ERRNO;
+ERROR 42S22: Unknown column 'a' in 'field list'
+GET DIAGNOSTICS CONDITION unknown_identifier.a.b @errno=MYSQL_ERRNO;
+ERROR 42S22: Unknown column 'b' in 'field list'
+GET DIAGNOSTICS CONDITION unknown_identifier.a.b.c @errno=MYSQL_ERRNO;
+ERROR 42S22: Unknown column 'b' in 'field list'
+PURGE BINARY LOGS BEFORE unknown_identifier;
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+PURGE BINARY LOGS BEFORE unknown_identifier.a;
+ERROR 42S22: Unknown column 'a' in 'field list'
+PURGE BINARY LOGS BEFORE unknown_identifier.a.b;
+ERROR 42S22: Unknown column 'b' in 'field list'
+PURGE BINARY LOGS BEFORE unknown_identifier.a.b.c;
+ERROR 42S22: Unknown column 'b' in 'field list'
+CREATE PROCEDURE p1()
+BEGIN
+DO unknown_identifier;
+END;
+$$
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+#
+# MDEV-15870 Using aggregate and window function in unexpected places can crash the server
+#
+# (aggreate functions)
+EXECUTE IMMEDIATE 'SELECT ?' USING SUM(1);
+ERROR HY000: Invalid use of group function
+CREATE PROCEDURE p1(a INT) BEGIN END;
+CALL p1(SUM(1));
+ERROR HY000: Invalid use of group function
+DROP PROCEDURE p1;
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=SUM(1);
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'SUM(1)' at line 1
+BEGIN NOT ATOMIC
+DECLARE CONTINUE HANDLER FOR SQLWARNING
+RESIGNAL SET MYSQL_ERRNO=SUM(1);
+SIGNAL SQLSTATE '01000';
+END;
+$$
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'SUM(1);
+SIGNAL SQLSTATE '01000';
+END' at line 3
+PREPARE stmt FROM SUM(1);
+ERROR HY000: Invalid use of group function
+EXECUTE IMMEDIATE SUM(1);
+ERROR HY000: Invalid use of group function
+GET DIAGNOSTICS CONDITION SUM(1) @errno=MYSQL_ERRNO;
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'SUM(1) @errno=MYSQL_ERRNO' at line 1
+PURGE BINARY LOGS BEFORE SUM(1);
+ERROR HY000: Invalid use of group function
+#
+# MDEV-15870 Using aggregate and window function in unexpected places can crash the server
+#
+# (window functions)
+EXECUTE IMMEDIATE 'SELECT ?' USING ROW_NUMBER() OVER ();
+ERROR HY000: Window function is allowed only in SELECT list and ORDER BY clause
+CREATE PROCEDURE p1(a INT) BEGIN END;
+CALL p1(ROW_NUMBER() OVER ());
+ERROR HY000: Window function is allowed only in SELECT list and ORDER BY clause
+DROP PROCEDURE p1;
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=ROW_NUMBER() OVER ();
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'ROW_NUMBER() OVER ()' at line 1
+BEGIN NOT ATOMIC
+DECLARE CONTINUE HANDLER FOR SQLWARNING
+RESIGNAL SET MYSQL_ERRNO=ROW_NUMBER() OVER ();
+SIGNAL SQLSTATE '01000';
+END;
+$$
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'ROW_NUMBER() OVER ();
+SIGNAL SQLSTATE '01000';
+END' at line 3
+PREPARE stmt FROM ROW_NUMBER() OVER ();
+ERROR HY000: Window function is allowed only in SELECT list and ORDER BY clause
+EXECUTE IMMEDIATE ROW_NUMBER() OVER ();
+ERROR HY000: Window function is allowed only in SELECT list and ORDER BY clause
+GET DIAGNOSTICS CONDITION ROW_NUMBER() OVER () @errno=MYSQL_ERRNO;
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'ROW_NUMBER() OVER () @errno=MYSQL_ERRNO' at line 1
+PURGE BINARY LOGS BEFORE ROW_NUMBER() OVER ();
+ERROR HY000: Window function is allowed only in SELECT list and ORDER BY clause
